=== debian/changelog ===
micropython (1.22.1+ds-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:55:44 +1100

micropython (1.22.1+ds-1build1) noble; urgency=medium

  * No-change rebuild against libmbedcrypto7t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 17 Mar 2024 18:08:54 +0000

micropython (1.22.1+ds-1) unstable; urgency=medium

  * New upstream release
    * Fix FTBFS with gcc 13 (Closes: #1042992)
  * Enable manifest to ship uasyncio (Closes: #1043530)
  * Disable all tests due to buggy code quality
  * Bump Standards-Version to 4.6.2

 -- Yangfl <mmyangfl@gmail.com>  Fri, 09 Feb 2024 21:23:24 +0800
